# Factorio Scripts

[Discord Message Link (Galaxy Discord - #general-discussion)](https://discord.com/channels/204965774618656769/753714180900519937/1140330697446412428)  
[Discord Message Link (seaswimmer (294518358420750336) & infern009 (420197112068964353) - Direct Messages)](https://discord.com/channels/@me/624776394676633663/1140332152530149447)

These four `.sh` files were created for Infern009's Factorio server, and use [Byobu](https://www.byobu.org/) to run a Factorio server.

## Usage

- Clone this repository, then cd into it.
  - `git clone https://git.seaswimmer.cc/SeaswimmerTheFsh/Factorio-Scripts.git && cd Factorio-Scripts`
- Make sure you have **Byobu** installed.
  - Alpine
    - `sudo apk add -y byobu`
  - Arch
    - `sudo pacman -Sy byobu`
  - CentOS/RHEL
    - `sudo yum install -y byobu`
  - Debian/Mint/Ubuntu
    - `sudo apt-get install -y byobu`
  - Gentoo
    - `sudo emerge -y byobu`
  - MacOS **(UNSUPPORTED)**
    - `sudo brew install byobu`
  - If none of these commands work for your platform, you can compile **Byobu** with the `install-byobu.sh` script.
- Run the `start_server.sh` script.
  - If you haven't changed **Byobu's** configuration, you can detach from the terminal this spawns by pressing `Ctrl + A`, releasing those keys, then immediately pressing `D`.
- Once the server is online, stop it with `/quit` from the Factorio server's console or by running the `stop_server.sh` script.
- Copy the `config.sh.example` file.
  - `cp config.sh.example config.sh`
- Modify the parameters in `config.sh`.
  - `save_name` - This parameter controls the name of the save file this script will use to start the server.
  - `version` - This parameter controls what version of Factorio the script will download. See the [Factorio archived downloads page](https://factorio.com/download/archive/) for a list of versions.
    - Set this parameter to `stable` if you want the most recent stable release of the game, and `latest` if you want the most recent experimental release.
  - If you have modified any default config files except for the `config.ini`, you'll want to change the commands' parameters to match those files. I'll assume you're storing them in the `./data` directory. You can find more arguments on the [Factorio Wiki](https://wiki.factorio.com/Command_line_parameters).
    - `extra_params_create=""` - This parameter adds additional flags to the `--create` command the script runs if a save matching `save_name` is not found.
      - `--map-gen-settings ./data/map-gen-settings.json`
      - `--map-settings ./data/map-settings.json`
    - `extra_params_start_server=""` - This parameter adds additional flags to the `-server-start` command.
      - `--server-settings ./data/server-settings.json`
- Run the `start_server.sh` script.
  - To stop the server, either run the `stop_server.sh` script from a terminal or type `/quit` into the Factorio server's console.
